/*!
 * @file kabewin.CC
 * @brief ɻ楦ɥ(֥ץ)
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2006-08-28
 *
 * Copyright (C) 2003-2006, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdio.h>
#include <bstdlib.h>
#include <bsyslog.h>
#include <bstring.h>
#include <tcode.h>
#include <errcode.h>
#include <btron/btron.h>
#include <btron/dp.h>
#include <btron/hmi.h>
#include <btron/vobj.h>
#include <btron/tip.h>
//#include <libapp.h>
#include <btron/cnvcol.h>

static W wid0 = -1;
static W mid0 = -1;
static WEVENT wev0;

static PAT bgpat = {{ 1, 0, 0, NULL, NULL }};
static TC fname[] = {TC_FDLM, L"ӣ٣"|TC_FDLM, L"£ǣӣãңţţΡ£ϣ"};

#define MENU_WINDOW 2

static TC mlist0[] = {MC_STR, L"ɥλ"};
static TC mlist1[] = {MC_STR, L"ɽ"|MC_STR, L"ɽ"};
static MENUITEM mitem[] = {
  {0, 0, 0, 0, mlist0},
  {0, 0, 0, 0, mlist1},
  {0, 0, 0, 0, NULL},
{0, 0, 0, 0, NULL},
};

static FSSPEC fstitle;
static PAT wframe;
static COLOR wtfcol = 0x10ffffff;
static COLOR wtbcol = 0x10999999;
static W titlefsize = 20;

// ǥ󥰤ΤΥɥ
#define MAXNWIN 256
static int nwin = -1;
static struct {
  W wid;
  RECT r;
  TC title[97];
} winf[MAXNWIN];

// ɥ󥢥ѥޥե
// (衦ɥ󹹿å Τɬ)
static W wininf_sem = -1;

void killme()
{
  int i;
  MESSAGE msg;

  gset_ptr(PS_BUSY, NULL, (COLOR)-1, (COLOR)-1);
  if (mid0 > 0)
    mdel_men(mid0);
  if (wid0 > 0)
    wcls_wnd(wid0, CLR);

  for (i = 0; i < bgpat.mpat.bmap->planes; i++){
    delete [] bgpat.mpat.bmap->baseaddr[i];
  }
  delete bgpat.mpat.bmap;

  // ƥץ˽λΤΥå
  msg.msg_type = MS_TYPE7;
  msg.msg_size = 4;
  snd_msg(-1, &msg, NOWAIT);

  ext_prc(0);
}

WID find_shade(PNT p)
{
  WID wid = -100;
  wai_sem(wininf_sem, T_FOREVER); // start critical
  for (int i = 0; i < nwin; i++) {
    if (winf[i].r.c.left <= p.x && p.x <= winf[i].r.c.right
        && winf[i].r.c.top <= p.y
        && p.y <= winf[i].r.c.top + titlefsize + 10) {
      wid = winf[i].wid;
      break;
    }
  }
  sig_sem(wininf_sem); // end critical
  return wid;
}

void update_wininf()
{
  W wids[MAXNWIN];
  int n = wget_inf(WI_WINLIST, wids, sizeof(W)*MAXNWIN) / sizeof(W);

  wai_sem(wininf_sem, T_FOREVER); // start critical

  nwin = 0;
  for (int i = 0; i < n; i++) {
    WDSTAT wstat;
    wget_sts(wids[i], &wstat, NULL);
    if ((wstat.attr & (WA_FRONT | WA_SUBW)) || wids[i] == wid0) {
      continue;
    }
    winf[nwin].wid = wids[i];
    winf[nwin].r = wstat.r;
    wcnv_rec(wstat.attr, &(winf[nwin].r), WA_FRAME);
    winf[nwin].title[0] = TNULL;
    wget_tit(wids[i], NULL, winf[nwin].title);
    nwin++;
  }

  sig_sem(wininf_sem); // end critical
}

void redisp(bool force)
{
  GID gid = wget_gid(wid0);

  do {
    if (wsta_dsp(wid0, NULL, NULL) == 0 && !force)
      break;
    wera_wnd(wid0, NULL);
    force = false;
    
    wai_sem(wininf_sem, T_FOREVER); // start critical
    for (int i = nwin-1; i >= 0; i--) {
      RECT r = winf[i].r;
      PAT pat1 = {{0, 1, 1, wtfcol, 0x10000000, FILL100}};
      PAT pat2 = {{0, 1, 1, wtbcol, 0x10000000, FILL100}};
      r.c.bottom = r.c.top + titlefsize + 10;
      gfil_rec(gid, r, &wframe, 0, G_STORE);
      gdra_lin(gid, r.p.lefttop, (PNT){r.c.right, r.c.top}, (LN_SOLID << 8) | 1, &pat1, G_STORE);
      gdra_lin(gid, r.p.lefttop, (PNT){r.c.left, r.c.bottom}, (LN_SOLID << 8) | 1, &pat1, G_STORE);
      gdra_lin(gid, (PNT){r.c.left, r.c.bottom}, r.p.rightbot, (LN_SOLID << 8) | 1, &pat2, G_STORE);
      gdra_lin(gid, (PNT){r.c.right, r.c.top}, r.p.rightbot, (LN_SOLID << 8) | 1, &pat2, G_STORE);

      gset_fon(gid, &fstitle);
      gset_chc(gid, wtbcol, 0x80000000 | wframe.spat.fgcol);
      gdra_stp(gid, r.c.left + 5, r.c.bottom - 6,
               winf[i].title, 97, G_STORE);
      gset_chc(gid, wtfcol, 0x80000000 | wframe.spat.fgcol);
      gdra_stp(gid, r.c.left + 6, r.c.bottom - 5,
               winf[i].title, 97, G_STORE);
    }
    sig_sem(wininf_sem); // end critical
  } while (wend_dsp(wid0) > 0);
}

void selectmenu(W i)
{
  switch (i >> 8){
      case 0:
        killme();
      case 1:
        switch (i & 0xff){
            case 1:
              wreq_dsp(wid0);
              break;
        }
        break;
      case MENU_WINDOW:
        wexe_dmn(i);
        break;
      case MENU_WINDOW+1:
        oexe_apg(0, i);
        break;
  }
}

void popupmenu()
{
  W i;

  wget_dmn(&(mitem[MENU_WINDOW].ptr));
  mset_itm(mid0, MENU_WINDOW, mitem+MENU_WINDOW);
  oget_men(0, NULL, &(mitem[MENU_WINDOW+1].ptr), NULL, NULL);
  mset_itm(mid0, MENU_WINDOW+1, mitem+MENU_WINDOW+1);
  
  gset_ptr(PS_SELECT, NULL, (COLOR)-1, (COLOR)-1);

  i = msel_men(mid0, wev0.s.pos);
  if (i > 0)
    selectmenu(i);
}
  
static void butdn()
{
  switch (wev0.s.cmd) {
      case W_PICT:
        switch (wchk_dck(wev0.s.time)) {
            case W_DCLICK:
              killme();
            case W_PRESS:
              break;
            default:
              return;
        }
      case W_FRAM:
      case W_TITL:
        if (wmov_drg(&wev0, NULL) > 0)
          redisp(false);
        break;
      case W_WORK:
        switch (wchk_dck(wev0.s.time)) {
            case W_DCLICK:
            case W_QPRESS:
              if (wget_act(NULL) == wev0.s.wid) {
                // ɥָ˰ư
                wexe_dmn(1);
              }
              break;
        }
        break;
  }
}

void parent_msg_handler(W ptid)
{
  MESSAGE msg;
  W ppid = prc_sts(-1, NULL, NULL);

  for (;;) {
    W err = rcv_msg(MM_TYPE5, &msg, sizeof(MESSAGE), WAIT|CLR);
    if (err == ppid) {
      PNT pos = *((PNT*)&(msg.msg_body));
      *((WID*)&(msg.msg_body)) = find_shade(pos);
      msg.msg_type = MS_TYPE5;
      msg.msg_size = sizeof(WID);
      snd_msg(-1, &msg, CONFM);
    }
  }
}

extern "C" W MAIN(MESSAGE *msg)
{
  RECT r0 = {{0, 0, 200, 200}}; // rightbottomϥߡ
  TC tit0[] = {L"ݡݡݡݡݡݡݡ"};
  W err, fd0, num, size, gid0, gid1;
  int i;
  UH recnum;
  LINK flnk;
  CSPEC cs0, cs1;
  DEV_SPEC ds;
  UB *tmpbmp = NULL;

  // databox
  err = dopn_dat(NULL);
  if (err < 0){
    pdsp_msg((TC[]){L"ƥǡܥåޤ"});
    sig_buz(0);
    killme();
  }
  // menu
  mid0 = mcre_men(MENU_WINDOW+2, mitem, NULL);
  if (mid0 < 0){
    pdsp_msg((TC[]){L"˥塼ϿǤޤ"});
    sig_buz(0);
    killme();
  }
  
  err = get_lnk(fname, &flnk, F_NORM);
  fd0 = opn_fil(&flnk, F_READ, NULL);

  // rectype=15Ƭ2ХȤɤ߹
  if (fnd_rec(fd0, F_TOPEND, 0x80008000U, 0, &num) >= 0){
    rea_rec(fd0, 0, (B*)&recnum, 2, NULL, NULL);
  }
  else {
    killme();
  }

  // ɻΤΥ쥳ɤɤ߹
  if (see_rec(fd0, recnum, 1, NULL) == 0){
    rea_rec(fd0, 0, NULL, 0, &size, NULL);
    tmpbmp = new UB[size];
    rea_rec(fd0, 0, (B*)tmpbmp, size, NULL, NULL);
    // BMP¤ΤȤν
    for (i = 0; i < ((BMP*)tmpbmp)->planes; i++){
      ((BMP*)tmpbmp)->baseaddr[i] += (int)tmpbmp;
    }
  }
  else {
    killme();
  }
  cls_fil(fd0);

  // طʥѥBMPʳʬ
  bgpat.mpat.hsize = ((BMP*)tmpbmp)->bounds.c.right
    - ((BMP*)tmpbmp)->bounds.c.left;
  bgpat.mpat.vsize = ((BMP*)tmpbmp)->bounds.c.bottom
    - ((BMP*)tmpbmp)->bounds.c.top;
  // bgpat.mpat.mask = FILL100;

  // SCREENCSPEC / DEV_SPEC
  gget_spc((TC[]){L"ӣãңţţ"}, &ds);
  r0.c.right = r0.c.left + ds.hpixels;
  r0.c.bottom = r0.c.top + ds.vpixels;  

  cs0.attr = ds.attr & 0x0f;
  cs0.info[0] = ds.color[0];
  cs0.info[1] = ds.color[1];
  cs0.info[2] = ds.color[2];
  cs0.info[3] = ds.color[3];
  cs0.colmap = NULL;

  // SCREENߴΥӥåȥޥåפκ
  bgpat.mpat.bmap = new BMP; // !
  bgpat.mpat.bmap->planes = ds.planes;
  bgpat.mpat.bmap->pixbits = ds.pixbits;
  bgpat.mpat.bmap->bounds.c.left = ((BMP*)tmpbmp)->bounds.c.left;
  bgpat.mpat.bmap->bounds.c.top = ((BMP*)tmpbmp)->bounds.c.top;
  bgpat.mpat.bmap->bounds.c.right = ((BMP*)tmpbmp)->bounds.c.right;
  bgpat.mpat.bmap->bounds.c.bottom = ((BMP*)tmpbmp)->bounds.c.bottom;
  bgpat.mpat.bmap->rowbytes
    = (bgpat.mpat.hsize * ((bgpat.mpat.bmap->pixbits & 0xff00) >> 8) / 16) * 2;// / bgpat.mpat.bmap->planes;
  for (i = 0; i < bgpat.mpat.bmap->planes; i++){
    bgpat.mpat.bmap->baseaddr[i] =
      new UB[bgpat.mpat.bmap->rowbytes * bgpat.mpat.vsize]; // !
  }
  gid0 = gopn_mem(NULL, bgpat.mpat.bmap, (B*)&cs0);

  // 顼ޥåפѴѤCSPEC
  GetStdCSPEC(&cs1, ((BMP*)tmpbmp)->planes, ((BMP*)tmpbmp)->pixbits);
  gid1 = gopn_mem(NULL, ((BMP*)tmpbmp), (B*)&cs1);
  
  // äBMPž(Ѵ)Ǥ
  gcop_bmp(gid1, &(((BMP*)tmpbmp)->bounds), gid0, NULL, NULL, G_STORE | G_CVFORM | G_CVCOLOR);

  gcls_env(gid0);
  gcls_env(gid1);
  
  delete [] tmpbmp;
  
  // ʲ̤Υɥ
  wid0 = wopn_wnd(WA_WORK, 0, &r0, NULL, 2, tit0, &bgpat, NULL);
  if (wid0 < 0)
    killme();

  // WID ƥץ
  MESSAGE widmsg;
  widmsg.msg_type = MS_TYPE6;
  widmsg.msg_size = sizeof(WID);
  *((WID*)&(widmsg.msg_body)) = wid0;
  snd_msg(-1, &widmsg, NOWAIT);

  wreq_dsp(wid0);

  // ޥե
  wininf_sem = cre_sem(1, SEM_EXCL|DELEXIT);

  // ɥָ˰ư
  wexe_dmn(1);
  
  // ֤ϤγƼ
  update_wininf();
  wget_inf(WI_TITLEFONT, &titlefsize, sizeof(W));
  wget_inf(WI_FSTITLE, &fstitle, sizeof(FSSPEC));
  wget_inf(WI_INACTWTFCOL, &wtfcol, sizeof(COLOR));
  wget_inf(WI_INACTWTBCOL, &wtbcol, sizeof(COLOR));
  wget_inf(WI_INACTFRAME, &wframe, sizeof(PAT));

  int pnwin = wlst_wnd(0, -1, NULL);
  int nwin;

  // MS_TYPE5 դư
  cre_tsk(parent_msg_handler, -1, get_tid());

  for (;;) {
    MESSAGE msg;
    wget_evt(&wev0, WAIT);

    // ߥ󥰤ˤäƤԽʬۤȤʤΤǤ
    nwin = wlst_wnd(0, -1, NULL);
    if (nwin != pnwin) {
      update_wininf();
      redisp(true);
      pnwin = nwin;
    }

    switch (wev0.s.type){
    case EV_NULL:
      if (wev0.s.wid != wid0)
	break;
      if (wev0.s.cmd != W_WORK)
	break;
      if (wev0.s.stat & ES_CMD)
	break;
      gset_ptr(PS_SELECT, NULL, (COLOR)-1, (COLOR)-1);
      break;
    case EV_REQUEST:
      switch (wev0.g.cmd) {
      case W_REDISP:
        update_wininf();
	redisp(false);
	break;
      case W_PASTE:
	wrsp_evt(&wev0, 1); // NACK
	break;
      case W_DELETE:
      case W_FINISH:
	wrsp_evt(&wev0, 0); // ACK
	killme();
      }
      break;
    case EV_RSWITCH:
      redisp(false);
    case EV_SWITCH:

    case EV_BUTDWN:
      butdn();
      break;
    case EV_INACT:
      break;
    case EV_DEVICE:
      oprc_dev(&wev0.e, NULL, 0);
      break;
    case EV_MSG:
      err = rcv_msg(MM_TYPE5, &msg, sizeof(MESSAGE), NOWAIT|NOCLR);
      if (err < 0) {
        clr_msg(~MM_TYPE5, MM_ALL);
      }
      else {
        W err = rcv_msg(MM_TYPE5, &msg, sizeof(MESSAGE), WAIT|CLR);
        if (err == prc_sts(-1, NULL, NULL)) {
          PNT pos = *((PNT*)&(msg.msg_body));
          *((WID*)&(msg.msg_body)) = find_shade(pos);
          msg.msg_type = MS_TYPE5;
          msg.msg_size = sizeof(WID);
          snd_msg(-1, &msg, CONFM);
        }
      }
      break;
    case EV_MENU:
      popupmenu();
      break;
    case EV_KEYDWN:
      if (wev0.s.stat & ES_CMD){
	i = mfnd_key(mid0, wev0.s.wid);
	if (i > 0)
	  selectmenu(i);
	break;
      }
    }
  }

  killme();
  return 0;
}
