/*!
 * @file main.cc
 * @brief ɥ(ᥤץ)
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2006-08-28
 *
 * Copyright (C) 2005-2006, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdio.h>
#include <bstring.h>
#include <bassert.h>
#include <btron/libapp.h>
#include <btron/vobj.h>
#include <tstring.h>

/*!
 * ʪư/ȵưåǤʤŬڤʽλԤ
 */
static bool checkExecution(const MESSAGE* msg)
{
  switch (msg->msg_type){
  case EXECREQ: // ȤΥץư
    return true;
  case FUSENREQ: // 䵤Υץư
    oend_prc(((M_FUSENREQ*)msg)->vid, NULL, 0);
    return false;
  case DISPREQ: // Ȥɽư
    oend_req(((M_DISPREQ*)msg)->vid, 1);
    return false;
  case PASTEREQ: // ǡŽߵư
    oend_req(((M_PASTEREQ*)msg)->vid, 1);
    return false;
  case TADREQ: // ȤTADǡư
    oend_req(((M_TADREQ*)msg)->vid, 1);
    return false;
  default:
    return false;
  }
  return false;
}

/*!
 * ƥ֥ɥΥȥʬΥץ쥹
 */
void onTitlePressed(WEVENT *ev)
{
  switch (wchk_dck(ev->s.time)) {
      case W_DCLICK:
        // Ctrl-W  (ָ˰ư뤿)
        clr_evt(EM_BUTDWN|EM_BUTUP|EM_KEYDWN|EM_KEYUP, EM_NULL);
        gcnv_abs(wget_gid(ev->s.wid), &(ev->e.pos));
        ev->e.type = EV_KEYDWN;
        ev->e.stat = 0x00020080;
        ev->e.data.key.keytop = 0x0011;
        ev->e.data.key.code = 0x2357;
        wpas_evt(ev);
        break;
      case W_CLICK:
        // wchk_dck Ǥʤʤä٥Ȥ⤦褵
        clr_evt(EM_BUTDWN|EM_BUTUP|EM_KEYDWN|EM_KEYUP, EM_NULL);
        wpas_evt(ev);
        gcnv_abs(wget_gid(ev->s.wid), &(ev->e.pos));
        ev->e.data.info = 0;
        ev->e.stat = 0;
        ev->e.type = EV_BUTUP;
        ev->e.time += 5;
        put_evt(&(ev->e), EP_NONE);
        break;
      case W_QPRESS:
        // wchk_dck Ǥʤʤä٥Ȥ⤦褵
        clr_evt(EM_BUTDWN|EM_BUTUP|EM_KEYDWN|EM_KEYUP, EM_NULL);
        wpas_evt(ev);
        gcnv_abs(wget_gid(ev->s.wid), &(ev->e.pos));
        ev->e.data.info = 0;
        ev->e.stat = 0;
        ev->e.type = EV_BUTUP;
        ev->e.time += 5;
        put_evt(&(ev->e), EP_NONE);
        ev->e.type = EV_BUTDWN;
        ev->e.time += 5;
        put_evt(&(ev->e), EP_NONE);
        break;
      case W_PRESS:
        // wchk_dck Ǥʤʤä٥Ȥ⤦褵
        wpas_evt(ev);
        break;
  }
}

static volatile bool cont;
static volatile WID  pwid = -100;
static W kabepid = -1;

#define MAXNWIN 256

/*
 * ɥꥹȤΥ˥塼/ɽ/
 * ("ɥ"ΥɤѤƤޤ)
 */
WID do_winlist_menu(PNT p)
{
  W wids[MAXNWIN];
  static struct {
    W wid;
    W parent;
    W next;
    W dig;
  } wdata[MAXNWIN+1];
  WID wact = wget_act(NULL);

  int n = wlst_wnd(0, MAXNWIN, wids);
  wdata[0].wid = 0;
  wdata[0].parent = 0;
  wdata[0].next = 0;
  wdata[0].dig = 0;
  int np = 1;

  // ɥξФ
  for (int i = 0; i < n; i++) {
    WDSTAT wstat;
    wget_sts(wids[i], &wstat, NULL);
    if ((wstat.attr & (WA_FRONT | WA_SUBW)) || wids[i] == pwid) {
      continue;
    }
    wdata[np].wid = wids[i];
    wdata[np].parent = wstat.parent;
    wdata[np].next = wdata[np].dig = 0;
    np++;
  }

  // ƥɥõnext, dig 
  for (int i = 1; i < np; i++) {
    int parent_idx = 0;

    if (wdata[i].parent != 0) {
      for (parent_idx = np-1; parent_idx > 0; parent_idx--) {
        if (wdata[parent_idx].wid == wdata[i].parent)
          break;
      }
    }
    wdata[i].next = wdata[parent_idx].dig;
    wdata[parent_idx].dig = i;
  }

  // ˥塼ܥǡ
  TC name[4096] = {MC_STR, TNULL};
  int name_len = 1;
  MENUITEM mitem = { 0, 0, 0, 0, name };

  int wpos[MAXNWIN];
  WID wid_list[MAXNWIN];
  int depth = 0;
  wpos[0] = wdata[0].dig;
  np = 0;

  do {
    int wdata_idx;
    
    wdata_idx = wpos[depth];
    wid_list[np] = wdata[wdata_idx].wid;

    name[name_len++] = 
      MC_STR | MC_IND | ((wact == wid_list[np]) ? MC_SEL : 0);
    if (depth > 0) {
      for (int i = 1; i < depth; i++) {
        name[name_len++] = (wpos[i]) ? L'' : L'';
      }
      name[name_len++] = (wdata[wpos[depth]].next) ? L'' : L'';
    }
    name[name_len] = TNULL;

    wget_tit(wid_list[np], NULL, &(name[name_len]));
    name_len += tc_strlen(&(name[name_len]));
    np++;

    wpos[depth] = wdata[wdata_idx].next;
    if (wdata[wdata_idx].dig) {
      wpos[++depth] = wdata[wdata_idx].dig;
    }
    else {
      while ((depth >= 0) && (wpos[depth] == 0)) {
        depth--;
      }
    }
  } while (depth >= 0);

  // ˥塼ɽ¹
  W mid = mcre_men(1, &mitem, NULL);
  W sel = msel_men(mid, p);
  mdel_men(mid);

  if (sel > 0) {
    return wid_list[(sel & 0xff) - 1];
  }
  else {
    return -2;
  }
}

/*!
 * ɥڤؤ
 * (wpas_evt ѤΤ)
 */
void activate_wid(WEVENT *wev, W wid, bool butev, int xdiff, int ydiff)
{
  wev->s.pos.x += xdiff;
  wev->s.pos.y += ydiff;
  wev->s.type = EV_BUTDWN;
  wev->s.cmd = W_TITL;
  wev->s.wid = wid;
  wpas_evt(wev);
  wev->s.pos.x -= xdiff;
  wev->s.pos.y -= ydiff;
  if (!butev) {
    wev->s.type = EV_BUTUP;
    put_evt((EVENT*)wev, EP_NONE);
  }
}

/*!
 * ٥ȥ롼
 */
W eventLoop(WID wid)
{
  WEVENT wev;
  W err;

  for (cont = true; cont; ) {
    WID wact;
    wget_evt(&wev, WAIT);

    switch (wev.s.type) {
        case EV_BUTDWN:
          wact = wget_act(NULL);
          if (wev.s.wid == -1) {
            // --- ƥåѥͥ
            PTRSTS psts;
            gget_ptr(&psts, NULL);
            W nw = do_winlist_menu(psts.pos);
            if (nw > 0) {
              activate_wid(&wev, nw, false, 0, 0);
            }
            else {
              wpas_evt(NULL);
            }
          }
          else if (wev.s.wid == wact && (wev.s.cmd == W_TITL || wev.s.cmd == W_FRAM)) {
            // --- ƥ֥ɥ(Υȥʬ)
            onTitlePressed(&wev);
          }
          else if (wev.s.wid == wid) {
            // --- ɥ
            wpas_evt(NULL);
          }
          else if (wev.s.wid == pwid && wev.s.cmd == W_WORK) {
            MESSAGE msg;
            msg.msg_type = MS_TYPE5;
            msg.msg_size = sizeof(PNT);
            *((PNT*)&(msg.msg_body)) = wev.s.pos;
            err = snd_msg(kabepid, &msg, CONFM);
            do {
              err = rcv_msg(MM_TYPE5, &msg, sizeof(MESSAGE), WAIT|CLR);
            } while (err != kabepid);

            W nw = *((W*)&(msg.msg_body));
            if (nw > 0) {
              WDSTAT wstat;
              RECT rwork;
              wget_sts(nw, &wstat, NULL);
              wget_wrk(nw, &rwork);
              wcnv_rec(wstat.attr, &(wstat.r), WA_WORK);

              activate_wid(&wev, nw, true, 
                           rwork.c.left - wstat.r.c.left,
                           rwork.c.top - wstat.r.c.top);
            }
            else if (wev.s.wid == wact) {
              wpas_evt(&wev);
            }
            else {
              switch (wchk_dck(wev.s.time)) {
                  case W_DCLICK:
                  case W_QPRESS:
                    wpas_evt(&wev);
                    break;
                  case W_CLICK:
                  case W_PRESS:
                    wpas_evt(NULL);
                    break;
              }
            }
          }
          else {
            // --- ¾
            wpas_evt(&wev);
          }
          break;
        case EV_REQUEST:
          if (wev.s.wid == wid) {
            switch (wev.s.cmd) {
                case W_REDISP:
                  do {
                    wsta_dsp(wid, NULL, NULL);
                    // wera_wnd(wid, NULL);
                  } while (wend_dsp(wid) > 0);
                  break;
                case W_PASTE:
                  wrsp_evt(&wev, 1); // NACK
                  break;
                case W_DELETE:
                case W_FINISH:
                  wrsp_evt(&wev, 0); // ACK
                  cont = false;
                  break;
            }
          }
          else {
            wpas_evt(&wev);
          }
          break;
        default:
          if (wev.s.wid == wid) {
            wpas_evt(NULL);
          }
          else {
            wpas_evt(&wev);
          }
          break;
    }
  }

  return 0;
}

/*!
 * ҥץνλΤ륿
 */
void child_checker(W childpid)
{
  for (;;) {
    MESSAGE msg;
    W err;

    err = rcv_msg(MM_TYPE7|MM_TYPE6, &msg, sizeof(msg), WAIT|CLR);
    if (err == childpid) {
      switch (msg.msg_type) {
          case MS_TYPE7:
            cont = false;
            ext_tsk();
            break;
          case MS_TYPE6:
            pwid = *((WID*)&(msg.msg_body));
            break;
      }
    }
  }
}

/*!
 * ᥤؿ
 */
extern "C" W MAIN(MESSAGE* msg)
{
  LINK self, kabelnk;
  W err = 0;
  TC kabepath[] = {
    TC_FDLM, L"ӣ٣"|TC_FDLM, L"Уңϣǣң͡£ϣ"|
    TC_FDLM, L"ףɣΣͣΣ"|TC_FDLM, L"" };
  RECT r = {{ -300, -300, -200, -200 }};
  TC title[] = {TNULL};
  
  if (!checkExecution(msg)){
    pdsp_msg((TC[]){L"ưˡǤ"});
    sig_buz(0);
    return -1;
  }
  
  dopn_dat(NULL);

  err = wdef_fep(1);
  if (err < 0) {
    pdsp_msg((TC[]){L"եȥɥץȤϿǤޤ"});
    sig_buz(0);
    return err;
  }

  WID wid = wopn_wnd(WA_FRONT|WA_TITL, 0, &r, NULL, 0, title, NULL, NULL);
  if (wid < 0) {
    return -1;
  }
  osta_prc(((M_EXECREQ*)msg)->vid, wid);

  get_lnk(kabepath, &kabelnk, F_NORM);
  kabepid = cre_prc(&kabelnk, -1, msg);

  cre_tsk(child_checker, -1, kabepid);

  gset_ptr(PS_SELECT, NULL, (COLOR)-1, (COLOR)-1);
  err = eventLoop(wid);

  gset_ptr(PS_BUSY, NULL, (COLOR)-1, (COLOR)-1);
  oend_prc(((M_EXECREQ*)msg)->vid, NULL, 0);
  wcls_wnd(wid, CLR);

  wdef_fep(0);

  ext_prc(err);
}

